// 002 u_c_integer_stack
// 10 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_integer_stack;
  interface
    uses Classes, u_c_basic_object;

    type c_integer_stack= // "integer_stack" list
                         Class(c_basic_object)
                           m_c_integer_stack: tList;

                           Constructor create_integer_stack(p_name: String);

                           function f_integer_stack(p_stack_index: Integer): integer;
                           procedure push_integer(p_integer: integer);
                           function f_pop_integer: integer;
                           function f_top_of_stack_integer: integer;
                           procedure display_integer_stack;

                           Destructor Destroy; Override;
                         end; // c_integer_stack

  implementation
    uses SysUtils, u_c_display, u_strings;

    // -- c_integer_stack

    Constructor c_integer_stack.create_integer_stack(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_integer_stack:= tList.Create;
      end; // create_integer_stack_line

    function c_integer_stack.f_integer_stack(p_stack_index: Integer): integer;
      begin
        Result:= integer(m_c_integer_stack[p_stack_index]);
      end; //  f_integer_stack

    procedure c_integer_stack.push_integer(p_integer: integer);
      begin
        m_c_integer_stack.Add(tObject(p_integer));
      end; // push_integer

    function c_integer_stack.f_top_of_stack_integer: integer;
      begin
        Result:= f_integer_stack(m_c_integer_stack.Count- 1);
      end; // f_top_of_stack_integer

    function c_integer_stack.f_pop_integer: integer;
      begin
        Result:= f_top_of_stack_integer;
        with m_c_integer_stack do
          Delete(Count- 1);
      end; // f_pop_integer

    procedure c_integer_stack.display_integer_stack;
      var l_integer_stack: Integer;
      begin
        for l_integer_stack:= 0 to m_c_integer_stack.Count- 1 do
          display(IntToStr(f_integer_stack(l_integer_stack)));
      end; // display_integer_stack

    Destructor c_integer_stack.Destroy;
      begin
        m_c_integer_stack.Free;
        Inherited;
      end; // Destroy

    begin // u_c_integer_stack
    end. // u_c_integer_stack

