// 002 u_graphic
// 10 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

// -- rectangles etc

(*$r+*)

unit u_graphic;
  interface
    uses Windows  // tTextMetrics, tRect
        , Graphics;

    type t_wh_rectangle= Record
                           m_left, m_top, m_width, m_height: Integer;
                         end;

    function f_display_wh_rectangle(p_left, p_top, p_width, p_height: Integer): String;
    function f_display_rectangle(p_rectangle: tRect): String;
    function f_wh_rectangle(p_left, p_top, p_width, p_height: Integer): t_wh_rectangle;
    function f_display_the_wh_rectangle(p_wh_rectangle: t_wh_rectangle): String;

    const k_color_array: array[0..2] of Integer= (clYellow, clLime, clAqua);
    var s_color_index: Integer= 0;

    function f_color_name(p_color_value: Integer): String;

    procedure display_font_heights(p_c_canvas: tCanvas);
    function f_font_leadding(p_c_canvas: tCanvas): Integer;

  implementation
    uses
          SysUtils // , TypInfo
        , u_c_display
        ;

    function f_display_wh_rectangle(p_left, p_top, p_width, p_height: Integer): String;
      begin
        Result:= Format('%4d %4d  %4d %4d', [p_left, p_top, p_width, p_height]);
      end; // f_display_wh_rectangle

    function f_display_rectangle(p_rectangle: tRect): String;
      begin
       with p_rectangle do
         Result:= f_display_wh_rectangle(Left, Top, Right, Bottom)
      end; // f_display_rectangle

    function f_wh_rectangle(p_left, p_top, p_width, p_height: Integer): t_wh_rectangle;
      begin
        with Result do
        begin
          m_left:= p_left; m_top:= p_top; m_width:= p_width; m_height:= p_height;
        end;
     end; // f_wh_rectangle

    function f_display_the_wh_rectangle(p_wh_rectangle: t_wh_rectangle): String;
      begin
        with p_wh_rectangle do
          Result:= f_display_wh_rectangle(m_left, m_top, m_width, m_height);
      end; // f_display_the_wh_rectangle

    function f_color_name(p_color_value: Integer): String;
      begin
        if p_color_value= clRed
          then Result:= 'clRed' else
        if p_color_value= clGreen
          then Result:= 'clGreen' else
        if p_color_value= clBlue
          then Result:= 'clBlue' else

        if p_color_value= clYellow
          then Result:= 'clYellow' else
        if p_color_value= clAqua
          then Result:= 'clAqua' else
        if p_color_value= clLime
          then Result:= 'clLime' else
        if p_color_value= clFuchsia
          then Result:= 'clFuchsias' else
        if p_color_value= clBlack
          then Result:= 'clBlack' else
        if p_color_value= clWhite
          then Result:= 'clWhite' else
          Result:= IntToHex(p_color_value, 4);  
        // Result:= GetEnumName(TypeInfo(tColorRef), p_color_value);
        // Delete(Result, 1, 2);     clRed
        // Delete(Result, Length(Result)- Length('_symbol')+ 1, Length('_symbol'));
      end; // f_color_name

    procedure display_font_heights(p_c_canvas: tCanvas);
      var l_font_metrics: tTextMetric;
      begin
        with p_c_canvas do
        begin
          GetTextMetrics(Handle, l_font_metrics);
          display(IntToStr(l_font_metrics.tmInternalLeading));
        end;
      end; // with p_c_canvas

    function f_font_leadding(p_c_canvas: tCanvas): Integer;
      var l_font_metrics: tTextMetric;
      begin
        GetTextMetrics(p_c_canvas.Handle, l_font_metrics);
        Result:= l_font_metrics.tmInternalLeading;
      end; // f_font_leadding
      
    begin // u_strings
    end. // u_strings

