// 003 u_lexi
// 04 feb 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)
unit u_lexi;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    exit_: TButton;
    clear_: TButton;
    create_: TButton;
    ScrollBox1: TScrollBox;
    display_: TButton;
    draw_: TButton;
    Panel2: TPanel;
    xy_panel_: TPanel;
    container_panel_: TPanel;
    PaintBox1: TPaintBox;
    display_hierarchy_: TButton;
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    square_: TRadioButton;
    round_: TRadioButton;
    clear_lexi_: TButton;
    generate_: TButton;
    list_: TButton;
    draw_control_: TButton;
    draw_glyph_: TButton;
    place_: TButton;
    Button1: TButton;
    text_: TButton;
    justification_edit_: TEdit;
    UpDown1: TUpDown;
    focus_edit_: TEdit;
    random_: TButton;
    bitmap_name_edit_: TEdit;
    go_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure draw_Click(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure clear_lexi_Click(Sender: TObject);
    procedure create_Click(Sender: TObject);
    procedure generate_Click(Sender: TObject);
    procedure display_Click(Sender: TObject);
    procedure display_hierarchy_Click(Sender: TObject);
    procedure list_Click(Sender: TObject);
    procedure draw_control_Click(Sender: TObject);
    procedure draw_glyph_Click(Sender: TObject);
    procedure place_Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure text_Click(Sender: TObject);
    procedure justification_edit_KeyPress(Sender: TObject; var Key: Char);
    procedure focus_edit_KeyPress(Sender: TObject; var Key: Char);
    procedure random_Click(Sender: TObject);
    procedure go_Click(Sender: TObject);
  private
  public
    procedure increase_the_font_height_click;
    procedure decrease_the_font_height_click;
    procedure add_frame_click;
    procedure add_scrollbar_click;
    procedure handle_memo_mouse_down(p_x, p_y: Integer);
    procedure handle_memo_mouse_move(p_x, p_y: Integer);
    procedure handle_memo_mouse_up(p_x, p_y: Integer);
  end;

    var Form1: TForm1;

  implementation
    uses u_types_constants, u_c_log, u_c_display
        , u_dir, u_file
        , u_graphic

        , u_c_control
        , u_c_square_controls
        , u_c_round_controls

        , u_c_widget_factory

        , u_c_bridge_canvas
        , u_c_bridge_drawings

        , u_c_document
        , u_c_glyph
    ;

  
    {$R *.DFM}

    var g_c_control_list: c_control_list= Nil;
        g_c_canvas: c_abstract_canvas= Nil;
        g_c_widget_factory: c_abstract_widget_factory= Nil;
        g_c_document: c_document= Nil;
        g_c_font_label_widget: c_abstract_label_widget= Nil;

    procedure display_square_or_round;
      begin
        if Form1.square_.Checked
          then display('width-height square')
          else display('p1-p2 rounded');
      end; // display_square_or_round

    procedure TForm1.add_frame_click;
      begin
        if g_c_document<> Nil
          then g_c_document.add_frame;
      end; // add_frame_click

    procedure TForm1.add_scrollbar_click;
      begin
        if g_c_document<> Nil
          then g_c_document.add_scrollbar(g_c_widget_factory);
      end; // add_scrollbar_click

    procedure tForm1.handle_memo_mouse_down(p_x, p_y: Integer);
      begin
        g_c_document.handle_mouse_down(p_x, p_y);
      end; // handle_memo_mouse_down

    procedure tForm1.handle_memo_mouse_move(p_x, p_y: Integer);
      begin
        g_c_document.handle_mouse_move(p_x, p_y);
      end; // handle_memo_mouse_move

    procedure tForm1.handle_memo_mouse_up(p_x, p_y: Integer);
      begin
        g_c_document.handle_mouse_up(p_x, p_y);
      end; // handle_memo_mouse_up

    procedure display_font_height;
      begin
        with Form1, g_c_document do
         if square_.Checked
           then
             with (g_c_font_label_widget as c_square_label_widget).m_c_square_label_control do
             begin
               m_caption:= 'font='+ IntToStr(m_font_height);
               draw_control;
             end
           else
             with (g_c_font_label_widget as c_round_label_widget).m_c_round_label_control do
             begin
               m_caption:= 'font='+ IntToStr(m_font_height);
               draw_control;
             end
      end; // display_font_height

    procedure TForm1.increase_the_font_height_click;
      begin
        if g_c_document<> Nil
          then
            with g_c_document do
            begin
              increase_font_height_click;
              display_font_height;
            end;
      end; // increase_the_font_height_click

    procedure TForm1.decrease_the_font_height_click;
      begin
        if g_c_document<> Nil
          then
            with g_c_document do
            begin
              decrease_font_height_click;
              display_font_height;
            end;
      end; // decrease_the_font_height_click

    // -- mouse events propagated to the control list

    procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
      begin
        if g_c_control_list<> Nil
          then g_c_control_list.handle_mouse_down(X, Y);
      end; // PaintBox1MouseDown

    procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
        Y: Integer);
      begin
        xy_panel_.Caption:= Format('x =%4d, y =%4d', [X, Y]);
        if g_c_control_list<> Nil
          then g_c_control_list.handle_mouse_move(X, Y);
      end; // PaintBox1MouseMove

    procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
      begin
        if g_c_control_list<> Nil
          then g_c_control_list.handle_mouse_up(X, Y);
        ActiveControl:= focus_edit_;
      end; // PaintBox1MouseUp

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        with container_panel_ do
        begin
          Left:= 2; Top:= 2; Width:= ScrollBox1.Width- 20; Height:= ScrollBox1.Height- 20;
        end;

        with PaintBox1 do
        begin
          Left:= 2; Top:= 2; Width:= container_panel_.Width- 4; Height:= container_panel_.Height- 4;
        end;

        justification_edit_.Text:= IntToStr(k_justification_width);
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.clear_lexi_Click(Sender: TObject);
        // -- remove any drawing in the drawing area
      begin
        PaintBox1.Repaint;
      end; // clear_lexi_Click

    procedure TForm1.create_Click(Sender: TObject);
        // -- use an abstract factory to build the "button lexi" setup
      var l_running_y, l_running_x: Integer;

      procedure add_button(p_caption: String; p_width: Integer; p_click_event: t_on_click);
        begin
          with g_c_widget_factory do
            f_c_create_button_widget(p_caption, l_running_x, l_running_y, p_width, k_button_default_height,
                p_click_event);
          Inc(l_running_x, p_width+ 5);
        end; // add_button

      function f_c_add_label_widget(p_caption: String; p_width: Integer): c_abstract_label_widget;
        begin
          with g_c_widget_factory do
            Result:= f_c_create_label_widget(p_caption, l_running_x, l_running_y, p_width, k_button_default_height);
          Inc(l_running_x, p_width+ 5);
        end; // f_c_add_label_widget

      var l_c_memo_client_region_drawing : c_client_region_drawing;
          l_memo_rectangle: t_wh_rectangle;

      begin // create_Click
        g_c_control_list:= c_control_list.create_control_list('surface', PaintBox1);

        display_square_or_round;
        if square_.Checked
          then g_c_widget_factory:= c_square_widget_factory.create_square_widget_factory('square_fact', g_c_control_list)
          else g_c_widget_factory:= c_round_widget_factory.create_round_widget_factory('round_fact', g_c_control_list);

        // -- now all the calls look the same, whether round or square library
        with g_c_widget_factory do
        begin
          l_running_x:= 5;
          l_running_y:= 5;

          add_button('frame_button', 35, add_frame_click);
          add_button('scroll_button', 35, add_scrollbar_click);

          l_memo_rectangle:= f_wh_rectangle(5, 5+ 4* (k_button_default_height+ 5),
              PaintBox1.Width- 10- 20, PaintBox1.Height- 5- 4* (k_button_default_height+ 5)- 5);
          with l_memo_rectangle do
          begin
            f_c_create_draw_surface_widget('memo', m_left, m_top, m_width, m_height,
                handle_memo_mouse_down, handle_memo_mouse_move, handle_memo_mouse_up);
            // -- add a custom scrollbar
            f_c_create_scrollbar_widget('scroll_bar', m_left+ m_width+ 5, m_top, 15, m_height);
          end;

          // Free;
        end; // with l_c_widget_factory

        // -- now add the generic drawing surface for the characters
        if square_.Checked
          then g_c_canvas:= c_square_canvas.create_square_canvas('square_device', g_c_control_list)
          else g_c_canvas:= c_round_canvas.create_round_canvas('round_device', g_c_control_list);

        // -- on the drawing survace, use a "canvas"
        with l_memo_rectangle do
          l_c_memo_client_region_drawing:= c_client_region_drawing.create_client_region_drawing('memo_client',
              g_c_canvas,
              m_left+ 2, m_top+ 2, m_width- 4, m_height- 4);

        g_c_document:= c_document.create_document('document',
            l_c_memo_client_region_drawing);

        with g_c_document do
        begin
          m_font_height:= - PaintBox1.Canvas.Font.Height;
          m_justification_width:= StrToInt(justification_edit_.Text);
          m_bitmap_name:= bitmap_name_edit_.Text;

          Inc(l_running_x, 5);
          add_button('-_button', 15, decrease_the_font_height_click);
          g_c_font_label_widget:= f_c_add_label_widget('font='+ IntToStr(m_font_height), 45);
          add_button('+_button', 15, increase_the_font_height_click);
          Inc(l_running_x, 5);
          add_button('Esc_button', 25, undo_command_click);

          Inc(l_running_x, 5);

          Inc(l_running_y, k_button_default_height+ 5);
          l_running_x:= 5;
          add_button('list_button', 25, list_glyphs_click);
          add_button('count_button', 35, count_glyphs_click);
          add_button('spell_button', 33, check_spelling_click);

          Inc(l_running_y, k_button_default_height+ 5);
          l_running_x:= 5;
          add_button('<justify_button', 43, justify_to_the_left_click);
          add_button('|justify|_button', 43, justify_both_sides_click);
          add_button('justify >_button', 47, justify_to_the_right_click);
          add_button('justify Z_button', 47, justify_page_click);

          Inc(l_running_y, k_button_default_height+ 5);
          l_running_x:= 5;
          add_button('letter', 40, insert_letter_click);
          add_button('rectangle', 53, insert_rectangle_click);
          add_button('bitmap', 50, insert_bitmap_click);
        end; // with g_c_document
      end; // create_Click

    // -- user action on tFomr

    procedure TForm1.draw_control_Click(Sender: TObject);
      begin
        if g_c_control_list<> Nil
          then g_c_control_list.draw_control_list;
      end; // draw_control_Click

    procedure TForm1.draw_glyph_Click(Sender: TObject);
      begin
        if g_c_document<> Nil
          then // g_c_document.draw_document;
               g_c_document.draw_page_and_caret;
      end; // draw_glyph_Click

    procedure TForm1.draw_Click(Sender: TObject);
      begin
        draw_control_Click(Nil);
        draw_glyph_Click(Nil);
      end; // draw_Click

    procedure TForm1.generate_Click(Sender: TObject);
        // -- create the composite and fill it with some characters
      begin
        if g_c_document<> Nil
          then g_c_document.generate_initial_content;
      end; // generate_Click

    procedure TForm1.random_Click(Sender: TObject);
      begin
        if g_c_document<> Nil
          then g_c_document.generate_random_content;
      end; // random_Click

    procedure TForm1.display_Click(Sender: TObject);
      begin
        if g_c_document<> Nil
          then g_c_document.display_document;
      end; // display_Click

    procedure TForm1.display_hierarchy_Click(Sender: TObject);
      begin
        if g_c_document<> Nil
          then g_c_document.display_glyph_hierarchy;
      end; // display_hierarchy_Click

    procedure TForm1.text_Click(Sender: TObject);
        // -- only the character content
      begin
        if g_c_document<> Nil
          then g_c_document.display_text;
      end; // text_Click

    procedure TForm1.list_Click(Sender: TObject);
      begin
        if g_c_control_list<> Nil
          then g_c_control_list.display_control_list;
      end; // list_Click

    procedure TForm1.place_Click(Sender: TObject);
      begin
        if g_c_document<> Nil
          then g_c_document.m_c_root_page_glyph.compute_placement;
      end; // place_Click

    procedure TForm1.Button1Click(Sender: TObject);
        // -- trials
      begin
(*
        with g_c_control_list, m_c_canvas_ref do
        begin
          Rectangle(100, 100, 150, 120);
          m_c_save_canvas_stack.push_save_canvas;
          Pen.Color:= clRed;
          Pen.Width:= 2;
          Brush.Color:= clYellow;
          Brush.Style:= bsClear;
          Rectangle(80, 105, 120, 170);
          m_c_save_canvas_stack.pop_save_canvas;
          Rectangle(70, 115, 95, 180);
        end;
*)
        with PaintBox1, Canvas do
        begin
          display(Font.Name+ ' h='+ IntToStr(Font.Height)+ ' Sz='+ IntToStr(Font.Size)
              + ' txtH'+ IntToStr(TextHeight('A')));
          display_font_heights(Canvas);    
        end;
      end;

    procedure TForm1.justification_edit_KeyPress(Sender: TObject;
        var Key: Char);
      begin
        if (g_c_document<> Nil) and (Key= Chr(13))
          then begin
              g_c_document.m_justification_width:= StrToInt(justification_edit_.Text);
              Caption:= 'Right ='+ IntToStr(g_c_document.m_justification_width);
              Key:= Chr(0);
            end;
      end; // justification_edit_KeyPress

    procedure TForm1.focus_edit_KeyPress(Sender: TObject; var Key: Char);
      begin
        if g_c_document<> Nil
          then begin
              display('key '+ Key+ '<');
              g_c_document.do_insert_command(Key);
            end;
      end; // focus_edit_KeyPress

    procedure TForm1.go_Click(Sender: TObject);
        // -- for debuggin
      begin
        create_Click(Nil);
        random_Click(Nil);

        add_frame_Click;
        with g_c_document do
        begin
          justify_to_the_right_click;

        end;
      end; // go_Click

end.


