// 002 u_c_command
// 10 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_command;
  interface
    uses Classes
        , u_c_basic_object
        ;

    type c_abstract_command= class(c_basic_object)
                               //Constructor create_abstract_command(p_name: String);
                               procedure execute_command; Virtual; Abstract;

                               function f_display_command: String; Virtual;
                               // function f_c_self: c_abstract_command;

                               // -- for undo
                               function f_is_reversible: Boolean; Virtual; Abstract;
                               procedure undo_command; Virtual; Abstract;
                               // Destructor Destroy; Override;
                             end; // c_abstract_command

         c_command_stack= // "command" list
                         Class(c_basic_object)
                           m_c_command_stack: tStringList;

                           Constructor create_command_stack(p_name: String);

                           function f_command_count: Integer;
                           function f_c_command(p_command_index: Integer): c_abstract_command;
                           function f_index_of(p_command_name: String): Integer;
                           function f_c_find_by_command(p_command_name: String): c_abstract_command;

                           function f_is_empty: Boolean;
                           function f_c_push_command(p_c_command: c_abstract_command): c_abstract_command;
                           function f_c_peek_command: c_abstract_command;
                           function f_c_pop_command: c_abstract_command;

                           procedure undo_command;

(*
                           procedure add_command(p_command_name: String; p_c_command: c_abstract_command);
                           function f_c_add_command(p_command_name: String): c_abstract_command;
                           function f_c_add_unique_command(p_command_name: String): c_abstract_command;
*)
                           procedure display_command_stack;

                           Destructor Destroy; Override;
                         end; // c_command_stack

  implementation
    uses SysUtils
        , u_c_display
        ;

(*
    // -- c_abstract_command

    Constructor c_abstract_command.create_abstract_command(p_name: String);
      begin
        Inherited create_basic_object(p_name);
      end; // create_abstract_command
*)

    function c_abstract_command.f_display_command: String;
      begin
      end; // f_display_command
(*
    // function f_c_self: c_abstract_command;
    Destructor c_abstract_command.Destroy;
      begin
        Inherited;
      end; // Destroy
*)
    // -- c_command_stack

    Constructor c_command_stack.create_command_stack(p_name: String);
      begin
        Inherited create_basic_object(p_name);

        m_c_command_stack:= tStringList.Create;
      end; // create_command_line

    function c_command_stack.f_command_count: Integer;
      begin
        Result:= m_c_command_stack.Count;
      end; // f_command_count

    function c_command_stack.f_c_command(p_command_index: Integer): c_abstract_command;
      begin
        Result:= c_abstract_command(m_c_command_stack.Objects[p_command_index]);
      end; //  f_c_command

    function c_command_stack.f_index_of(p_command_name: String): Integer;
      begin
        Result:= m_c_command_stack.IndexOf(p_command_name);
      end; // f_index_of

    function c_command_stack.f_c_find_by_command(p_command_name: String): c_abstract_command;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_command_name);
        if l_index_of< 0
          then Result:= Nil
          else Result:= c_abstract_command(m_c_command_stack.Objects[l_index_of]);
      end; // f_c_find_by_name

    function c_command_stack.f_is_empty: Boolean;
      begin
        Result:= f_command_count= 0;
      end; // f_is_empty

    function c_command_stack.f_c_push_command(p_c_command: c_abstract_command): c_abstract_command;
      begin
        Result:= p_c_command;
        m_c_command_stack.AddObject(Result.m_name, Result);
      end; // f_c_push_command

    function c_command_stack.f_c_peek_command: c_abstract_command;
      begin
        if f_is_empty
          then Result:= Nil
          else Result:= f_c_command(f_command_count- 1);
      end; // f_c_peek_command

    function c_command_stack.f_c_pop_command: c_abstract_command;
        // -- the user MUST free the command
      begin
        if f_is_empty
          then Result:= Nil
          else begin
              Result:= f_c_command(f_command_count- 1);
              // -- delete the string and the cell in the tStringList
              m_c_command_stack.Delete(f_command_count- 1); // , m_c_command_stack);
            end;
      end; // f_c_pop_command

(*
    procedure c_command_stack.add_command(p_command_name: String; p_c_command: c_abstract_command);
      begin
        m_c_command_stack.AddObject(p_command_name, p_c_command);
      end; // add_command

    function c_command_stack.f_c_add_command(p_command_name: String): c_abstract_command;
      begin
        Result:= f_c_command(m_c_command_stack.AddObject(p_command_name, c_command.create_command(p_command_name)));
      end; // f_c_add_command

    function c_command_stack.f_c_add_unique_command(p_command_name: String): c_command;
      var l_index_of: Integer;
      begin
        l_index_of:= f_index_of(p_command_name);
        if l_index_of>= 0
          then Result:= f_c_command(l_index_of)
          else Result:= f_c_add_command(p_command_name);
      end; // f_c_add_unique_command
*)
    procedure c_command_stack.display_command_stack;
      var l_command_index: Integer;
      begin
        display(m_name+ ' '+ IntToStr(f_command_count));

        for l_command_index:= 0 to f_command_count- 1 do
          display(f_c_command(l_command_index).f_display_command);
      end; // display_command_stack

    procedure c_command_stack.undo_command;
      var l_c_command: c_abstract_command;
      begin
        if not f_is_empty
          then begin
              l_c_command:= f_c_pop_command;
              l_c_command.undo_command;
              l_c_command.Free;
            end;
      end; // undo_command

    Destructor c_command_stack.Destroy;
      var l_command_index: Integer;
      begin
        for l_command_index:= 0 to f_command_count- 1 do
          f_c_command(l_command_index).Free;
        m_c_command_stack.Free;

        Inherited;
      end; // Destroy

    begin // u_c_abstract_command
    end. // u_c_abstract_command
