// 002 u_c_glyph_border_decorator_kinds_2
// 10 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_glyph_border_decorator_kinds_2;
  interface
    uses ExtCtrls
        , u_c_bridge_drawings

        , u_c_glyph
        , u_c_page_glyph
        , u_c_glyph_border_decorator_2
        , u_c_widget_factory
        ;

    type c_frame_decorator= class(c_abstract_border_decorator)
                               Constructor create_frame_decorator(p_name: String;
                                   p_c_parent_glyph: c_glyph;
                                   p_c_enclosed_glyph: c_page_glyph);
                               procedure draw(p_c_client_region_drawing: c_client_region_drawing); Override;
                               procedure compute_placement; Override;
                               Destructor Destroy; Override;
                             end; // c_frame_decorator

         c_scrollbar_decorator= class(c_abstract_border_decorator)
                                  m_c_scrollbar_drawing: c_scrollbar_drawing;

                                  Constructor create_scrollbar_decorator(p_name: String;
                                      p_c_parent_glyph: c_glyph;
                                      p_c_enclosed_glyph: c_page_glyph;
                                      p_c_scrollbar_drawing: c_scrollbar_drawing);
                                  function f_display_glyph: String; Override;
                                  procedure draw(p_c_client_region_drawing: c_client_region_drawing); Override;
                                  procedure shrink(p_delta_left, p_delta_top, p_delta_right, p_delta_bottom: Integer); Override;
                                  Destructor Destroy; Override;
                                end; // c_scrollbar_decorator

  implementation
    uses Graphics
        , u_c_display;

    // -- c_frame_decorator

    Constructor c_frame_decorator.create_frame_decorator(p_name: String;
        p_c_parent_glyph: c_glyph;
        p_c_enclosed_glyph: c_page_glyph);
      begin
        Inherited create_abstract_border_decorator(p_name, p_c_parent_glyph, p_c_enclosed_glyph);

        // NO -- limits are the enclosed limits before the shrink
        // m_width_max:= _m_c_enclosed_glyph.m_width_max+ k_enclosed_fat;
        // m_height_max:= _m_c_enclosed_glyph.m_height_max+ k_enclosed_fat;
      end; // create_frame_decorator

    procedure c_frame_decorator.draw(p_c_client_region_drawing: c_client_region_drawing);
      begin
        display('> draw_frame '+ f_display_glyph);
        // -- draw the border
        with p_c_client_region_drawing do
        begin
          save_graphic_context;
          set_pen_color(clLime);
          set_brush_style(bsClear);

          draw_rectangle(m_x, m_y, m_width_max, m_height_max);
          restore_graphic_context;
        end; // with p_c_client_region_drawing

        // -- draw the enclosed content
        Inherited; //  draw(p_c_client_region_drawing)
        display('< draw_frame');
      end; // draw

    procedure c_frame_decorator.compute_placement;
      begin
        // -- compute the placement for the content
        Inherited;
      end; // compute_placement

    Destructor c_frame_decorator.Destroy;
      begin
        // _m_c_border_panel.Free;
        Inherited;
      end; // Destroy

    // -- c_scrollbar_decorator

    Constructor c_scrollbar_decorator.create_scrollbar_decorator(p_name: String;
        p_c_parent_glyph: c_glyph;
        p_c_enclosed_glyph: c_page_glyph;
        p_c_scrollbar_drawing: c_scrollbar_drawing);
      begin
        Inherited create_abstract_border_decorator(p_name, p_c_parent_glyph, p_c_enclosed_glyph);

        m_c_scrollbar_drawing:= p_c_scrollbar_drawing;
      end; // create_scrollbar_decorator

    function c_scrollbar_decorator.f_display_glyph: String;
      begin
        Result:= m_c_scrollbar_drawing.f_display_drawing;
          // + ' ['+ _m_c_enclosed_glyph.f_display_glyph+ ']';
      end; // f_display_glyph

    procedure c_scrollbar_decorator.draw(p_c_client_region_drawing: c_client_region_drawing);
      begin
        display('> draw_scroll '+ f_display_glyph);
        m_c_scrollbar_drawing.draw_content;

        // -- draw the enclosed content
        Inherited;
        // stop('draw_scb '+ m_name);
        display('< draw_scroll');
      end; // draw

    procedure c_scrollbar_decorator.shrink(p_delta_left, p_delta_top, p_delta_right, p_delta_bottom: Integer);
      begin
        display('> shrink_scroll_dec');
        // -- shrink the scrollbar
        m_c_scrollbar_drawing.shrink_drawing(p_delta_left, p_delta_top, p_delta_right, p_delta_bottom);
        display('< shrink_scroll_dec');
      end; // shrink

    Destructor c_scrollbar_decorator.Destroy;
      begin
        Inherited;
      end; // Destroy

    begin // u_c_border_decorator
    end. // u_c_border_decorator



