// 002 u_c_widget_factory
// 10 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_widget_factory;
  interface
    uses u_c_basic_object
        , u_c_control
        , u_c_square_controls
        , u_c_round_controls
        ;

    const k_button_default_height= 20;

    type // -- definitions only for the Virtual Abstract functions in the factory
         c_abstract_button_widget= Class(c_basic_object)
                                   end; // c_abstract_button_widget
         c_abstract_label_widget= Class(c_basic_object)
                                  end; // c_abstract_label_widget
         c_abstract_draw_surface_widget= Class(c_basic_object)
                                         end; // c_abstract_draw_surface_widget
         c_abstract_scrollbar_widget= Class(c_basic_object)
                                       end; // c_abstract_draw_surface_widget

         c_abstract_widget_factory= class(c_basic_object)
                                      m_c_control_list_ref: c_control_list;

                                      Constructor create_abstract_widget_factory(p_name: String;
                                          p_c_control_list_ref: c_control_list);

                                      function f_c_create_button_widget(p_caption: String;
                                          p_left, p_top, p_width, p_height: Integer;
                                          p_on_click: t_on_click): c_abstract_button_widget; Virtual; Abstract;
                                      function f_c_create_label_widget(p_caption: String;
                                          p_left, p_top, p_width, p_height: Integer): c_abstract_label_widget; Virtual; Abstract;
                                      function f_c_create_draw_surface_widget(p_caption: String;
                                          p_left, p_top, p_width, p_height: Integer;
                                          p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down): c_abstract_draw_surface_widget; Virtual; Abstract;
                                      function f_c_create_scrollbar_widget(p_caption: String;
                                          p_left, p_top, p_width, p_height: Integer): c_abstract_scrollbar_widget; Virtual; Abstract;

                                      procedure create_2_buttons(p_left, p_top, p_width, p_height: Integer);
                                    end; // c_abstract_widget_factory

         // -- the width height square widgets

         c_square_button_widget= Class(c_abstract_button_widget)
                                   m_c_square_button_control: c_square_button_control;
                                   Constructor create_square_button_widget(p_name: String;
                                       p_c_abstract_widget_factory: c_abstract_widget_factory;
                                       p_left, p_top, p_width, p_height: Integer;
                                       p_on_click: t_on_click);
                                 end; // c_square_button_widget
         c_square_label_widget= Class(c_abstract_label_widget)
                                  m_c_square_label_control: c_square_label_control;
                                  Constructor create_square_label_widget(p_name: String;
                                      p_c_abstract_widget_factory: c_abstract_widget_factory;
                                      p_left, p_top, p_width, p_height: Integer);
                                end; // c_square_label_widget
         c_square_draw_surface_widget= Class(c_abstract_draw_surface_widget)
                                         m_c_square_draw_surface_control: c_square_draw_surface_control;
                                         Constructor create_square_draw_surface_widget(p_name: String;
                                             p_c_abstract_widget_factory: c_abstract_widget_factory;
                                             p_left, p_top, p_width, p_height: Integer;
                                             p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down);
                                       end; // c_square_draw_surface_widget
         c_square_scrollbar_widget= Class(c_abstract_scrollbar_widget)
                                       m_c_square_scrollbar_control: c_square_scrollbar_control;
                                       Constructor create_square_scrollbar_widget(p_name: String;
                                           p_c_abstract_widget_factory: c_abstract_widget_factory;
                                           p_left, p_top, p_width, p_height: Integer);
                                     end; // c_square_scrollbar_widget
         c_square_widget_factory= class(c_abstract_widget_factory)
                                    Constructor create_square_widget_factory(p_name: String;
                                        p_c_control_list_ref: c_control_list);

                                    function f_c_create_button_widget(p_caption: String;
                                        p_left, p_top, p_width, p_height: Integer;
                                        p_on_click: t_on_click): c_abstract_button_widget; Override;
                                    function f_c_create_label_widget(p_caption: String;
                                        p_left, p_top, p_width, p_height: Integer): c_abstract_label_widget; Override;
                                    function f_c_create_draw_surface_widget(p_caption: String;
                                        p_left, p_top, p_width, p_height: Integer;
                                        p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down): c_abstract_draw_surface_widget; Override;
                                    function f_c_create_scrollbar_widget(p_caption: String;
                                        p_left, p_top, p_width, p_height: Integer): c_abstract_scrollbar_widget; Override;
                                  end; // c_abstract_factory

         // -- the 2 points round widgets

         c_round_button_widget= Class(c_abstract_button_widget)
                                  m_c_round_button_control: c_round_button_control;
                                  Constructor create_round_button_widget(p_name: String;
                                      p_c_abstract_widget_factory: c_abstract_widget_factory;
                                      p_left, p_top, p_width, p_height: Integer;
                                      p_on_click: t_on_click);
                                end; // c_round_button_widget
         c_round_label_widget= Class(c_abstract_label_widget)
                                  m_c_round_label_control: c_round_label_control;
                                  Constructor create_round_label_widget(p_name: String;
                                      p_c_abstract_widget_factory: c_abstract_widget_factory;
                                      p_left, p_top, p_width, p_height: Integer);
                               end; // c_round_label_widget
         c_round_draw_surface_widget= Class(c_abstract_draw_surface_widget)
                                        m_c_round_draw_surface_control: c_round_draw_surface_control;
                                        Constructor create_round_draw_surface_widget(p_name: String;
                                            p_c_abstract_widget_factory: c_abstract_widget_factory;
                                            p_left, p_top, p_width, p_height: Integer;
                                            p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down);
                                      end; // c_round_draw_surface_widget

         c_round_scrollbar_widget= Class(c_abstract_scrollbar_widget)
                                     m_c_round_scrollbar_control: c_round_scrollbar_control;
                                     Constructor create_round_scrollbar_widget(p_name: String;
                                         p_c_abstract_widget_factory: c_abstract_widget_factory;
                                         p_left, p_top, p_width, p_height: Integer);
                                   end; // c_round_scrollbar_widget
         c_round_widget_factory= class(c_abstract_widget_factory)
                                  Constructor create_round_widget_factory(p_name: String;
                                      p_c_control_list_ref: c_control_list);

                                  function f_c_create_button_widget(p_caption: String;
                                      p_left, p_top, p_width, p_height: Integer;
                                      p_on_click: t_on_click): c_abstract_button_widget; Override;
                                  function f_c_create_label_widget(p_caption: String;
                                      p_left, p_top, p_width, p_height: Integer): c_abstract_label_widget; Override;
                                  function f_c_create_draw_surface_widget(p_caption: String;
                                      p_left, p_top, p_width, p_height: Integer;
                                      p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down): c_abstract_draw_surface_widget; Override;
                                  function f_c_create_scrollbar_widget(p_caption: String;
                                      p_left, p_top, p_width, p_height: Integer): c_abstract_scrollbar_widget; Override;
                               end; // c_abstract_factory

  implementation
    uses SysUtils
        , u_c_display
        ;

    // -- c_abstract_widget_factory

    Constructor c_abstract_widget_factory.create_abstract_widget_factory(p_name: String;
        p_c_control_list_ref: c_control_list);
      begin
        Inherited create_basic_object(p_name);
        m_c_control_list_ref:= p_c_control_list_ref;
      end; // create_abstract_widget_factory

    procedure c_abstract_widget_factory.create_2_buttons(p_left, p_top, p_width, p_height: Integer);
      var l_height_fraction: Integer;
      begin
        l_height_fraction:= p_height div 5;
        f_c_create_button_widget('button_1', p_left+ 4, l_height_fraction,
            p_width- 8, l_height_fraction, Nil);
        f_c_create_button_widget('button_2', p_left+ 4, 3* l_height_fraction,
            p_width- 8, l_height_fraction, Nil);
      end; // create_2_buttons

    // -- c_square_button

    Constructor c_square_button_widget.create_square_button_widget(p_name: String;
        p_c_abstract_widget_factory: c_abstract_widget_factory;
        p_left, p_top, p_width, p_height: Integer;
        p_on_click: t_on_click);
      begin
        Inherited create_basic_object(p_name);

        // -- this creates the button AND attaches it to the control list
        m_c_square_button_control:= c_square_button_control.create_square_button_control(p_name,
            p_c_abstract_widget_factory.m_c_control_list_ref,
            p_left, p_top, p_left+ p_width, p_top+ p_height,
            p_on_click);
      end; // create_square_button_widget

   // -- c_square_label_widget

   Constructor c_square_label_widget.create_square_label_widget(p_name: String;
       p_c_abstract_widget_factory: c_abstract_widget_factory;
       p_left, p_top, p_width, p_height: Integer);
     begin
        Inherited create_basic_object(p_name);

        m_c_square_label_control:= c_square_label_control.create_square_label_control(p_name,
            p_c_abstract_widget_factory.m_c_control_list_ref,
            p_left, p_top, p_left+ p_width, p_top+ p_height);
     end; // c_square_label_widget

    // -- c_square_draw_surface_widget

    Constructor c_square_draw_surface_widget.create_square_draw_surface_widget(p_name: String;
        p_c_abstract_widget_factory: c_abstract_widget_factory;
        p_left, p_top, p_width, p_height: Integer;
        p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down);
      begin
        Inherited create_basic_object(p_name);

        m_c_square_draw_surface_control:= c_square_draw_surface_control.create_square_draw_surface_control(p_name,
            p_c_abstract_widget_factory.m_c_control_list_ref,
            p_left, p_top, p_left+ p_width, p_top+ p_height,
            p_on_mouse_down, p_on_mouse_move, p_on_mouse_up);
      end; // create_square_draw_surface_widget

   // -- c_square_scrollbar_widget

   Constructor c_square_scrollbar_widget.create_square_scrollbar_widget(p_name: String;
       p_c_abstract_widget_factory: c_abstract_widget_factory;
       p_left, p_top, p_width, p_height: Integer);
     begin
        Inherited create_basic_object(p_name);

        m_c_square_scrollbar_control:= c_square_scrollbar_control.create_square_scrollbar_control(p_name,
            p_c_abstract_widget_factory.m_c_control_list_ref,
            p_left, p_top, p_left+ p_width, p_top+ p_height);
     end; // c_square_scrollbar_widget

    // -- c_square_widget_factory

    Constructor c_square_widget_factory.create_square_widget_factory(p_name: String;
        p_c_control_list_ref: c_control_list);
      begin
        Inherited create_abstract_widget_factory(p_name, p_c_control_list_ref);
      end; // create_square_widget_factory

    function c_square_widget_factory.f_c_create_button_widget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer;
        p_on_click: t_on_click): c_abstract_button_widget;
      begin
        Result:= c_square_button_widget.create_square_button_widget(p_caption, Self,
            p_left, p_top, p_width, p_height, p_on_click);
      end; // f_c_create_button_widget

    function c_square_widget_factory.f_c_create_label_widget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer): c_abstract_label_widget;
      begin
        Result:= c_square_label_widget.create_square_label_widget(p_caption, Self,
            p_left, p_top, p_width, p_height);
      end; // f_c_create_label_widget

    function c_square_widget_factory.f_c_create_draw_surface_widget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer;
        p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down): c_abstract_draw_surface_widget;
      begin
        Result:= c_square_draw_surface_widget.create_square_draw_surface_widget(p_caption, Self,
            p_left, p_top, p_width, p_height,
            p_on_mouse_down, p_on_mouse_move, p_on_mouse_up);
      end; // f_c_create_draw_surface_widget

    function c_square_widget_factory.f_c_create_scrollbar_widget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer): c_abstract_scrollbar_widget;
      begin
        Result:= c_square_scrollbar_widget.create_square_scrollbar_widget(p_caption, Self,
            p_left, p_top, p_width, p_height);
      end; // f_c_create_scrollbar_widget

    // -- c_round_button_widget

    Constructor c_round_button_widget.create_round_button_widget(p_name: String;
        p_c_abstract_widget_factory: c_abstract_widget_factory;
        p_left, p_top, p_width, p_height: Integer;
        p_on_click: t_on_click);
      begin
        Inherited create_basic_object(p_name);

        // -- here adapts the parameter to the 2P world
        m_c_round_button_control:= c_round_button_control.create_round_button_control(p_name,
            p_c_abstract_widget_factory.m_c_control_list_ref,
            p_left, p_top, p_width, p_height / p_width,
            p_on_click);
      end; // create_round_button_widget

    // -- c_round_label_widget

    Constructor c_round_label_widget.create_round_label_widget(p_name: String;
        p_c_abstract_widget_factory: c_abstract_widget_factory;
        p_left, p_top, p_width, p_height: Integer);
      begin
        Inherited create_basic_object(p_name);

        // -- here adapts the parameter to the 2P world
        m_c_round_label_control:= c_round_label_control.create_round_label_control(p_name,
            p_c_abstract_widget_factory.m_c_control_list_ref,
            p_left, p_top, p_width, p_height / p_width);
      end; // create_round_label_widget

    // -- c_round_draw_surface_widget

    Constructor c_round_draw_surface_widget.create_round_draw_surface_widget(p_name: String;
        p_c_abstract_widget_factory: c_abstract_widget_factory;
        p_left, p_top, p_width, p_height: Integer;
        p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down);
      begin
        Inherited create_basic_object(p_name);

        // -- here adapts the parameter to the 2P world
        m_c_round_draw_surface_control:= c_round_draw_surface_control.create_round_draw_surface_control(p_name,
            p_c_abstract_widget_factory.m_c_control_list_ref,
            p_left, p_top, p_width, p_height / p_width,
            p_on_mouse_down, p_on_mouse_move, p_on_mouse_up)
      end; // create_round_draw_surface_widget

   // -- c_round_scrollbar_widget

   Constructor c_round_scrollbar_widget.create_round_scrollbar_widget(p_name: String;
       p_c_abstract_widget_factory: c_abstract_widget_factory;
       p_left, p_top, p_width, p_height: Integer);
     begin
        Inherited create_basic_object(p_name);

        m_c_round_scrollbar_control:= c_round_scrollbar_control.create_round_scrollbar_control(p_name,
            p_c_abstract_widget_factory.m_c_control_list_ref,
            p_left, p_top, p_width, p_height / p_width);
     end; // c_round_scrollbar_widget

    // -- c_round_widget_factory

    Constructor c_round_widget_factory.create_round_widget_factory(p_name: String;
        p_c_control_list_ref: c_control_list);
      begin
        Inherited create_abstract_widget_factory(p_name, p_c_control_list_ref);
      end; // create_round_widget_factory

    function c_round_widget_factory.f_c_create_button_widget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer;
        p_on_click: t_on_click): c_abstract_button_widget;
      begin
        Result:= c_round_button_widget.create_round_button_widget(p_caption, Self,
            p_left, p_top, p_width, p_height, p_on_click);
      end; // f_c_create_button_widget

    function c_round_widget_factory.f_c_create_label_widget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer): c_abstract_label_widget;
      begin
        Result:= c_round_label_widget.create_round_label_widget(p_caption, Self,
            p_left, p_top, p_width, p_height);
      end; // f_c_create_button_widget

    function c_round_widget_factory.f_c_create_draw_surface_widget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer;
        p_on_mouse_down, p_on_mouse_move, p_on_mouse_up: t_on_mouse_down): c_abstract_draw_surface_widget;
      begin
        Result:= c_round_draw_surface_widget.create_round_draw_surface_widget(p_caption, Self,
            p_left, p_top, p_width, p_height,
            p_on_mouse_down, p_on_mouse_move, p_on_mouse_up);
      end; // f_c_create_draw_surface_widget

    function c_round_widget_factory.f_c_create_scrollbar_widget(p_caption: String;
        p_left, p_top, p_width, p_height: Integer): c_abstract_scrollbar_widget;
      begin
        Result:= c_round_scrollbar_widget.create_round_scrollbar_widget(p_caption, Self,
            p_left, p_top, p_width, p_height);
      end; // f_c_create_scrollbar_widget

    begin // u_c_abstract_factory
    end. // u_c_abstract_factory
