// 002 u_c_glyph_count_visitor
// 10 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_glyph_count_visitor;
  interface
    uses u_c_visitor;

    type c_glyph_count_visitor= class(c_abstract_visitor)
                                  m_glyph_count: Integer;

                                  Constructor create_glyph_count_visitor(p_name: String);

                                  procedure visit_character(p_c_character_glyph: tObject); Override;
                                  procedure visit_row(p_c_row_glyph: tObject); Override;
                                end; // c_glyph_count_visitor

  implementation
    uses SysUtils, u_c_display
        , u_c_glyph_kinds;

    // -- c_glyph_count_visitor

    Constructor c_glyph_count_visitor.create_glyph_count_visitor(p_name: String);
      begin
        Inherited create_basic_object(p_name);
      end; // create_glyph_count_visitor

    procedure c_glyph_count_visitor.visit_character(p_c_character_glyph: tObject);
      var l_character: Char;
      begin
        l_character:= c_character_glyph(p_c_character_glyph).m_name[1];
        if l_character<> ' '
          then begin
              // display('count '+ c_character_glyph(p_c_character_glyph).m_name+ IntTOStr(m_glyph_count));
              Inc(m_glyph_count);
            end;
      end; // visit_character

    procedure c_glyph_count_visitor.visit_row(p_c_row_glyph: tObject);
      begin
      end; // visit_row

    begin // u_c_glyph_count_visitor
    end. // u_c_glyph_count_visitor
