// 002 u_c_spelling_checker_visitor
// 10 dec 2004

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_spelling_checker_visitor;
  interface
    uses Classes, u_c_visitor;

    type c_spelling_checker_visitor= class(c_abstract_visitor)
                                       m_word_to_check: String;
                                       m_c_mistake_list_ref: tStringList;

                                       Constructor create_spelling_checker_visitor(p_name: String;
                                           p_c_mistake_list_ref: tStringList);

                                         procedure _check_the_word;
                                       procedure visit_character(p_c_character_glyph: tObject); Override;
                                       procedure visit_row(p_c_row_glyph: tObject); Override;
                                     end; // c_spelling_checker_visitor

  implementation
    uses SysUtils, u_c_display
        , u_c_glyph_kinds;

    // -- c_spelling_checker_visitor

    Constructor c_spelling_checker_visitor.create_spelling_checker_visitor(p_name: String;
        p_c_mistake_list_ref: tStringList);
      begin
        Inherited create_basic_object(p_name);
        m_c_mistake_list_ref:= p_c_mistake_list_ref;
      end; // create_spelling_checker_visitor

    procedure c_spelling_checker_visitor._check_the_word;
      begin
        if m_word_to_check<> ''
          then begin
              if Pos('%', m_word_to_check)> 0
                then begin
                    display('*** '+ m_word_to_check);
                    m_c_mistake_list_ref.Add(m_word_to_check);
                  end
                else display('ok  '+ m_word_to_check);
              m_word_to_check:= '';
            end;
      end; // _check_the_word

    procedure c_spelling_checker_visitor.visit_character(p_c_character_glyph: tObject);
      var l_character: Char;
      begin
        l_character:= c_character_glyph(p_c_character_glyph).m_name[1];
        // display('spell '+ c_character_glyph(p_c_character_glyph).m_name);
        if l_character= ' '
          then _check_the_word
          else m_word_to_check:= m_word_to_check+ l_character;
      end; // visit_character

    procedure c_spelling_checker_visitor.visit_row(p_c_row_glyph: tObject);
      begin
        _check_the_word;
      end; // visit_row

    begin // u_c_spelling_checker_visitor
    end. // u_c_spelling_checker_visitor
